package com.sathish;

import java.awt.Color;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InvalidClassException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;


public class ConfigureData implements Serializable {
    private Map categories = new HashMap();
    private Color backColor = Color.yellow;
    private Color frontColor = Color.red;
    private int displayTime = 100;
    private int hideTime = 2900;
    private int loveMultiple = 4;
    private int startx=100;
    private int starty=100;
    private int endx=400;
    private int endy=400;
    private boolean alwaysOnTop = false;
    private boolean alwaysOnBack = true;
    private boolean hide = false;
    private boolean random=true;
    private boolean center=false;
    
    private ConfigureData() {
    categories.put("Love",Boolean.TRUE);
    categories.put("Health",Boolean.TRUE);
    categories.put("Motivation",Boolean.TRUE);
    }

    public static ConfigureData getInstance() {
        ConfigureData data = readConfiguration();

        if (data == null) {
            data = new ConfigureData();
            data.saveConfiguration(data);
        }

        System.out.println(data);

        return data;
    }

    static ConfigureData readConfiguration() {
        ObjectInputStream oin;

        try {
            oin = new ObjectInputStream(new FileInputStream(
                        "C:\\temp\\flasher.ser"));

            ConfigureData data = (ConfigureData) oin.readObject();

            return data;
        } catch (InvalidClassException e) {
            e.printStackTrace();
            new File("C:\\temp\\flasher.ser").delete();

            return null;
        } catch (Exception e) {
            e.printStackTrace();

            return null;
        }
    }

    public static void saveConfiguration(ConfigureData data) {
        try {
            ObjectOutputStream oout = new ObjectOutputStream(new FileOutputStream(
                        "C:\\temp\\flasher.ser"));
            oout.writeObject(data);
            System.out.println(data);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String toString() {
        return " Front Color : " + this.frontColor + " Back Color : " +
        this.backColor;
    }

    public Color getBackColor() {
        return backColor;
    }

    public void setBackColor(Color back) {
        this.backColor = back;
    }

    public Color getFrontColor() {
        return frontColor;
    }

    public void setFrontColor(Color front) {
        this.frontColor = front;
    }

    public int getDisplayTime() {
        return displayTime;
    }

    public void setDisplayTime(int displayTime) {
        this.displayTime = displayTime;
    }

    public int getHideTime() {
        return hideTime;
    }

    public void setHideTime(int hideTime) {
        this.hideTime = hideTime;
        System.out.println("Set to "+this.hideTime);
    }

    public int getLoveMultiple() {
        return loveMultiple;
    }

    public void setLoveMultiple(int loveMultiple) {
        this.loveMultiple = loveMultiple;
    }

    public boolean isAlwaysOnTop() {
        return alwaysOnTop;
    }

    public void setAlwaysOnTop(boolean alwaysOnTop) {
        this.alwaysOnTop = alwaysOnTop;
        alwaysOnBack = !alwaysOnTop;
    }

    public boolean isAlwaysOnBack() {
        return alwaysOnBack;
    }

    public void setAlwaysOnBack(boolean alwaysOnBack) {
        this.alwaysOnBack = alwaysOnBack;
        alwaysOnTop = !alwaysOnBack;
    }

    public boolean isHide() {
        return hide;
    }

    public void setHide(boolean hide) {
        this.hide = hide;
    }

    public boolean isRandom() {
        return random;
    }

    public void setRandom(boolean random) {
        this.random = random;
        this.center = !random;
    }

    public boolean isCenter() {
        return center;
    }

    public void setCenter(boolean center) {
        this.center = center;
        this.random = !center;
    }

    public int getStartx() {
        return startx;
    }

    public void setStartx(int startx) {
        this.startx = startx;
    }

    public int getStarty() {
        return starty;
    }

    public void setStarty(int starty) {
        this.starty = starty;
    }

    public int getEndx() {
        return endx;
    }

    public void setEndx(int endx) {
        this.endx = endx;
    }

    public int getEndy() {
        return endy;
    }

    public void setEndy(int endy) {
        this.endy = endy;
    }

    public Map getCategories() {
        return categories;
    }

    public void setCategories(Map categories) {
        this.categories = categories;
    }
}


