package com.sathish;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.util.*;

import javax.swing.SwingConstants;
import javax.swing.Timer;
import javax.swing.UIManager;


public class Flasher {
    static ConfigureData data = ConfigureData.getInstance();
    static final Flash frame = new Flash();

    public Flasher() {
        final Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        final Dimension frameSize = frame.getSize();

        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }

        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }

        frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
        frame.setLocation(0, 0);

        if(data.isCenter() == true)
        {
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        }

        frame.setVisible(true);

        final Thread t = new Thread() {
                public void run() {
                    try {
                    makeTable();
                        while (true) {
                            int idx = (int) (Math.random() * quotes.length);

                            if(data.isRandom() == true)
                            {
                            int x =(int) (Math.random() * (screenSize.width - frameSize.width));
                            int y =(int) (Math.random() * (screenSize.height - frameSize.height));
                            frame.setLocation(x,y);
                            }


                            frame.jLabel1.setText(quotes[idx]);

                            if (data.isHide() == false) {
                                frame.show();
                            }

                            if ((data.isAlwaysOnTop() == true) &&
                                    (data.isAlwaysOnBack() == false)) {
                                frame.toFront();
                                frame.requestFocus();
                            }

                            if ((data.isAlwaysOnBack() == true) &&
                                    (data.isAlwaysOnTop() == false)) {
                                frame.toBack();
                            }

                            this.sleep(data.getDisplayTime());
                            frame.hide();

                            this.sleep(data.getHideTime());
                        }
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            };

        t.start();
    }

String quotes[];
void makeTable()
{
Map categ = data.getCategories();
System.out.print(categ);
StringBuffer buffer = new StringBuffer(4096);
int i = 0;
for (Iterator itr = categ.entrySet().iterator(); itr.hasNext();) {
String category = (String) ((Map.Entry) itr.next()).getKey();
if(categ.get(category).toString().equals("true"))
{
//System.out.println("Selected "+category);
String read = new String(PmaTyperPanel.file2String(TestFrame.path+TestFrame.prefix+category+TestFrame.suffix));
//System.out.println(" read "+read+" over ");
buffer.append(read);
buffer.append("\n");
}//if
   }//for
StringTokenizer tkns = new StringTokenizer(buffer.toString(),"\n");
quotes = new String[tkns.countTokens()];
while(tkns.hasMoreTokens() == true)
{
quotes[i] = tkns.nextToken();
//System.out.println(quotes[i]);
i++;
} //while
} //makeTable()

static ConfigureData onReconfigure() {
        try
        {
          data = ConfigureData.getInstance();
          frame.onReconfigure();
          //PmaTray.data = data;
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }

        return data;
    }

    /**
     *
     * @param args
     */
    public static void main(String[] args) {
        try {
            //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }

        new Flasher();
    }
}
