package com.sathish;

import org.jdesktop.jdic.tray.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


public class PmaTray implements ActionListener, ItemListener {
    static ConfigureData data = Flasher.data;
    SystemTray tray = SystemTray.getDefaultSystemTray();
    TrayIcon ti;

    public PmaTray() {
        new Flasher();

        JPopupMenu menu;
        JMenu submenu;
        JMenuItem menuItem;
        JRadioButtonMenuItem rbMenuItem;
        JCheckBoxMenuItem cbMenuItem;
        System.setProperty("javax.swing.adjustPopupLocationToFit", "false");
        menu = new JPopupMenu("Pma Menu");

        // a group of JMenuItems
        menuItem = new JMenuItem("Show", KeyEvent.VK_T);

        menuItem.addActionListener(this);
        menu.add(menuItem);

        menuItem = new JMenuItem("Hide");

        menuItem.addActionListener(this);
        menu.add(menuItem);

        // a group of radio button menu items
        menu.addSeparator();

        ButtonGroup group = new ButtonGroup();

        rbMenuItem = new JRadioButtonMenuItem("Front");
        rbMenuItem.setSelected(true);

        group.add(rbMenuItem);
        rbMenuItem.addActionListener(this);
        menu.add(rbMenuItem);

        rbMenuItem = new JRadioButtonMenuItem("Back");

        group.add(rbMenuItem);
        rbMenuItem.addActionListener(this);
        menu.add(rbMenuItem);
        menu.addSeparator();

        menuItem = new JMenuItem("Configure...");

        menuItem.addActionListener(this);
        menu.add(menuItem);

        // "Quit" menu item
        menu.addSeparator();
        menuItem = new JMenuItem("Quit");
        menuItem.addActionListener(this);
        menu.add(menuItem);

        ImageIcon i = new ImageIcon(
                "C:/jdic-0.9-bin-windows/demo/Tray/images/duke.gif");

        ti = new TrayIcon(i, "Pma Flasher", menu);

        ti.setIconAutoSize(true);

        tray.addTrayIcon(ti);
    }

    // Returns just the class name -- no package info.
    protected String getClassName(Object o) {
        String classString = o.getClass().getName();
        int dotIndex = classString.lastIndexOf(".");

        return classString.substring(dotIndex + 1);
    }

    public void actionPerformed(ActionEvent e) {
        JMenuItem source = (JMenuItem) (e.getSource());
        String s = source.getText();

        if (s.equalsIgnoreCase("Quit")) {
            System.out.println("Quit menu item selected!");
            System.exit(0);
        } else if (s.equalsIgnoreCase("Front")) {
            System.out.println("Front menu item selected!");
            data.setAlwaysOnTop(true);
        } else if (s.equalsIgnoreCase("Back")) {
            System.out.println("Back menu item selected!");
            data.setAlwaysOnBack(true);
        } else if (s.equalsIgnoreCase("Hide")) {
            System.out.println("Hide menu item selected!");
            data.setHide(true);
        } else if (s.equalsIgnoreCase("Show")) {
            System.out.println("Show menu item selected!");
            data.setHide(false);
        } else if (s.equalsIgnoreCase("Configure...")) {
            try {
                System.out.println("Configure... menu item selected!");
                new FlashConfigure();
                data = Flasher.data;
            } catch (Exception ef) {
                ef.printStackTrace();
            }
        } else {
            s = "Action event detected." + "\n" + "    Event source: " +
                source + " (an instance of " + getClassName(source) + ")";

            System.out.println(s);
        }
    }

    public void itemStateChanged(ItemEvent e) {
        JMenuItem source = (JMenuItem) (e.getSource());
        String s = "Item event detected." + "\n" + "    Event source: " +
            source.getText() + " (an instance of " + getClassName(source) +
            ")" + "\n" + "    New state: " +
            ((e.getStateChange() == ItemEvent.SELECTED) ? "selected"
                                                        : "unselected");

        System.out.println(s);
    }

    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }

        new PmaTray();
    }
}
