package com.sathish;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;


public class TableFileEditorModel extends AbstractTableModel {
    String fileName;
    String dataString;
    int rows;
    Vector data = new Vector();
    String[] names = { "Quote", };

    public TableFileEditorModel(String fileName) {
        super();

        try {
            this.fileName = fileName;

            File f = new File(fileName);
            if(f.exists() == false)
            {
              f.createNewFile();
            }
            FileReader fr = new FileReader(f);
            StringBuffer buffer = new StringBuffer(4096);
            char[] datac = new char[4096];

            while (fr.read(datac) != -1)
                buffer.append(datac);

            dataString = buffer.toString().trim();

            StringTokenizer tkns = new StringTokenizer(dataString, "\n");
            rows = tkns.countTokens();

            for (; tkns.hasMoreTokens();) {
                String read = tkns.nextToken();
                data.add(read);
            }
        } 
       
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public int getColumnCount() {
        return 1;
    }

    public int getRowCount() {
        return rows;
    }

    public Object getValueAt(int row, int col) {
        return data.get(row);
    }

    public boolean isCellEditable(int row, int col) {
        return true;
    }

    public void setValueAt(Object aValue, int row, int column) {
        data.set(row, aValue);
        System.out.println(row + " " +aValue);
    }

    public String getColumnName(int column) {
        return names[column];
    }

    public void save() {
        try {
            FileWriter fw = new FileWriter(fileName);
            StringBuffer buffer = new StringBuffer(4096);

            for (Iterator itr = data.iterator(); itr.hasNext();) {
                String value = itr.next().toString();
                buffer.append(value + "\n");
            }

            System.out.println("saved "+ fileName);
            fw.write(buffer.toString());
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    void add() {
        data.add("");
        this.fireTableRowsInserted(rows, rows + 1);
        rows++;
    }

    void delete(int[] rows) {
        for (int i = 0; i < rows.length; i++) {
            System.out.println(rows[0]);
            data.removeElementAt(rows[0]);

            this.fireTableRowsDeleted(rows[0], rows[0] + 1);
        }

        this.rows -= rows.length;
    }

    void clear(int[] rows) {
        for (int i = 0; i < rows.length; i++) {
            System.out.println(rows[0]);
            data.setElementAt("", rows[0] + i);
            this.fireTableDataChanged();
        }
    }
    
    void remove()
    {
      File f = new File(fileName);
      System.out.println(f.delete() + " " + f);
    }
}
